/* algorithm samples */
#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

void myfunction (int i) {
  cout << " " << i;
}

struct myclass {
  int counter;
  myclass(int n=0):counter(n){}
  void operator() (int i) {++counter; cout << " " << i;}
} myobject;

bool IsOdd (int i) {
  return ((i%2)==1);
}

bool sortfunction (int i,int j) { return (i<j); }

struct sortclass {
  bool operator() (int i,int j) { return (i<j);}
} mysort_obj;

void print(const vector<int>& myv){
  cout << "\nmyvector contains:";
  for_each (myv.begin(), myv.end(), myfunction);
  cout << endl;
}

int main () {
  vector<int> myvector;
  myvector.push_back(14);
  myvector.push_back(21);
  myvector.push_back(30);

  cout << "myvector contains:";
  for_each (myvector.begin(), myvector.end(), myfunction);

  // or:
  cout << "\nmyvector contains:";
  cout <<endl<< "nyomtatva: " <<(for_each (myvector.begin(), myvector.end(), myclass())).counter;
  //vagy myobject a myclass() helyett

  cout << endl;
  vector<int>::iterator it = find_if (myvector.begin(), myvector.end(), IsOdd);
  cout << "The first odd value is " << *it << endl;

  cout << endl;
  int mycount = count_if (myvector.begin(), myvector.end(), IsOdd);
  cout << "myvector contains " << mycount  << " odd values.\n";

  cout << endl;
  replace (myvector.begin(), myvector.end(), 21, 777);
  print(myvector);

  cout << endl;

  fill (myvector.begin()+1,myvector.end()-1,8);
  print(myvector);

  cout << endl;

  sort (myvector.begin(), myvector.end(), mysort_obj);
  //vagy sortclass() a mysor_obj helyett
  print(myvector);

  return 0;
}
